#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define MAX_SIZE 300

/* 
Recibirá por STDIN los minisat files correspondientes 
(los tomo separados con un \n aunque esto podría modificarse luego)
y, a su vez, entregará por STDOUT el resultado de minisat.

Ejemplo de uso: echo "prueba.txt" | ./slave.o 
*/

void printSystemError(char *);
void runCommand(char *, char *);
void printOutput(char *, char *);
int copyUpToNewline(char *, char *, int);

int main(int argc, char *argv[]) {
    setvbuf(stdout, NULL, _IONBF, 0);

    char output[MAX_SIZE];
    char input[MAX_SIZE];

    // Falta manejo de errores de fgets!
    while (fgets(input, MAX_SIZE, stdin)) {
	//input[strcspn(input, "\n")] = '\0';
	input[strlen(input) - 1] = '\0';
	runCommand(input, output);
	printOutput(output, input);
    }
}

void runCommand(char * inputLine, char * output) {
    char command[MAX_SIZE];
    sprintf(command, "minisat %s | grep -o -e \"Number of .*[0-9]\\+\" -e \"CPU time.*\" -e \".*SATISFIABLE\" |  awk '{if (NR == 1) {print $4} ; if (NR == 2) {print $4} ; if (NR == 3) {print $4 $5} ; if (NR == 4) {print $1}}'", inputLine);
    // Pequeña ayuda para popen: https://stackoverflow.com/questions/646241/c-run-a-system-command-and-get-output
    FILE *fp;
    if (!(fp = popen(command, "r")))
	printSystemError("slave.c -- popen()");

    // Ver manejo de errores de fread!
    size_t outputLength = fread(output, sizeof(char), MAX_SIZE, fp);
    output[outputLength] = '\0';

    if (pclose(fp) < 0)
	printSystemError("slave.c -- pclose()");

}

void printOutput(char * output, char * fileName) {
    printf("Nombre de archivo: %s - ", fileName);

    unsigned char lines = 1;
    // Ver si strtok puede fallar!
    char * outputLine = strtok(output, "\n");
    while (lines <= 4) {
	switch (lines) {
	    case 1:
		printf("Cantidad de variables: %s - ", outputLine);
		break;
	    case 2:
		printf("Cantidad de cláusulas: %s - ", outputLine);
		break;
	    case 3:
		printf("Tiempo de procesamiento: %s - ", outputLine);
		break;
	    case 4:
		printf("Resultado: %s\n", outputLine);
		break;
	    defeault:
		break;
	}
	lines++;
	outputLine = strtok(NULL, "\n");
    }

    //printf("Id del esclavo: %s", getpid());
}

void printSystemError(char * string) {
    perror(string);
    exit(EXIT_FAILURE);
}
